/*************************************************************************************\


 #     #   #####   #     #   #####    #####   ######      #  #######  #####   ######
 #     #  #     #  ##    #  #     #  #     #  #     #    #      #    #     #  #     #
 #  #  #  #     #  # #   #  #              #  #     #   #       #          #  #     #
 #  #  #  #######  #  #  #  # #####   #####   #     #  #   #    #     #####   #     #
 #  #  #  #     #  #   # #  #     #        #  #     #  #######  #          #  #     #
 #  #  #  #     #  #    ##  #     #  #     #  #     #      #    #    #     #  #     #      
  ## ##   #     #  #     #   #####    #####   ######       #    #     #####   ######


                                  Preprocessor of
                 3D Wang Tiles with Ellipsoidal Inclusions for T3D
                           Copyright: Daniel Rypl 2018

\*************************************************************************************/

/* IMPORTANT: this file is included in wang3d4t3d.c and uses static global variables defined there !!! */

#define process_aa_side_geometry                   process_x_side_geometry
#define check_inclusion_outside_tile_aa_side       check_inclusion_outside_tile_x_side
#define get_aa_side_patch_id_inner                 get_x_side_patch_id_inner
#define get_aa_side_patch_id_outer                 get_x_side_patch_id_outer
#define aa_intersection                            x_intersection
#define aa_touching                                x_touching
#define output_bb_edge_vertex                      output_y_edge_vertex
#define output_cc_edge_vertex                      output_z_edge_vertex
#define output_bb_edge_curve                       output_y_edge_curve
#define output_cc_edge_curve                       output_z_edge_curve
#define halving_bb                                 halving_y
#define halving_cc                                 halving_z
#define aa_face_is                                 x_face_is
#define bb_face_is                                 y_face_is
#define cc_face_is                                 z_face_is
#define bb_edge_is                                 y_edge_is
#define cc_edge_is                                 z_edge_is
#define aa_ind                                     x_ind
#define bb_ind                                     y_ind
#define cc_ind                                     z_ind
#define ind_aa                                     ind_x
#define ind_bb                                     ind_y
#define ind_cc                                     ind_z
#define bbbb_ind                                   yy_ind
#define cccc_ind                                   zz_ind
#define shift_aa                                   shift_x
#define shift_bb                                   shift_y
#define shift_cc                                   shift_z
#define bb_count                                   y_count
#define cc_count                                   z_count
#define aa_patch_id                                x_patch_id
#define bb_curve_id                                y_curve_id
#define cc_curve_id                                z_curve_id
#define sign_bb                                    sign_y
#define sign_cc                                    sign_z
#define aa_side_vertex_array                       x_side_vertex_array
#define aa_side_vertices                           x_side_vertices
#define bb_edge_vertex_id_array                    y_edge_vertex_id_array
#define cc_edge_vertex_id_array                    z_edge_vertex_id_array
#define bb_edge_vertex_data_array                  y_edge_vertex_data_array
#define cc_edge_vertex_data_array                  z_edge_vertex_data_array
#define bb_edge_vertices                           y_edge_vertices
#define cc_edge_vertices                           z_edge_vertices
#define bb_edge_curve_1_array                      y_edge_curve_1_array
#define cc_edge_curve_1_array                      z_edge_curve_1_array
#define bb_edge_curves_1                           y_edge_curves_1
#define cc_edge_curves_1                           z_edge_curves_1
#define bb_edge_curves_2                           y_edge_curves_2
#define cc_edge_curves_2                           z_edge_curves_2
#define aa_side_patch_array                        x_side_patch_array
#define aa_side_patches                            x_side_patches 
#ifndef HALF_MAX_TILES
#define aa_side_patches_total                      x_side_patches_total
#endif
#define aa_side_curve_array_inner                  x_side_curve_array_inner
#define aa_side_curve_array_outer                  x_side_curve_array_outer
#define aa_side_curves_inner                       x_side_curves_inner
#define aa_side_curves_outer                       x_side_curves_outer
#define dir_aa                                     dir_x

#define aa                                         x
#define bb                                         y
#define cc                                         z

#define AA                                         X
#define BB                                         Y
#define CC                                         Z

#define AABB                                       XY
#define AACC                                       XZ
#define BBAA                                       YX
#define CCAA                                       ZX

#ifdef DEBUG_PRINT
#define string_aa                                  "x"
#define string_bb                                  "y"
#define string_cc                                  "z"
#endif

#include "geom3d_xyz.c"

/* IMPORTANT: note that this file is included in wang3d4t3d.c
	 it is therefore necessary to undef all above directives to prevent their application to code following the inclusion */

#undef process_aa_side_geometry
#undef check_inclusion_outside_tile_aa_side
#undef get_aa_side_patch_id_inner
#undef get_aa_side_patch_id_outer
#undef aa_intersection
#undef aa_touching
#undef output_bb_edge_vertex
#undef output_cc_edge_vertex
#undef output_bb_edge_curve
#undef output_cc_edge_curve
#undef halving_bb
#undef halving_cc
#undef aa_face_is
#undef bb_face_is
#undef cc_face_is
#undef bb_edge_is
#undef cc_edge_is
#undef aa_ind
#undef bb_ind
#undef cc_ind
#undef ind_aa
#undef ind_bb
#undef ind_cc
#undef bbbb_ind
#undef cccc_ind
#undef shift_aa
#undef shift_bb
#undef shift_cc
#undef bb_count
#undef cc_count
#undef aa_patch_id
#undef bb_curve_id
#undef cc_curve_id
#undef sign_bb
#undef sign_cc
#undef aa_side_vertex_array
#undef aa_side_vertices
#undef bb_edge_vertex_id_array
#undef cc_edge_vertex_id_array
#undef bb_edge_vertex_data_array
#undef cc_edge_vertex_data_array
#undef bb_edge_vertices
#undef cc_edge_vertices
#undef bb_edge_curve_1_array
#undef cc_edge_curve_1_array
#undef bb_edge_curves_1
#undef cc_edge_curves_1
#undef bb_edge_curves_2
#undef cc_edge_curves_2
#undef aa_side_patch_array
#undef aa_side_patches
#ifndef HALF_MAX_TILES
#undef aa_side_patches_total
#endif
#undef aa_side_curve_array_inner
#undef aa_side_curve_array_outer
#undef aa_side_curves_inner
#undef aa_side_curves_outer
#undef dir_aa

#undef aa
#undef bb
#undef cc

#undef AA
#undef BB
#undef CC

#undef AABB
#undef AACC
#undef BBAA
#undef CCAA

#ifdef DEBUG_PRINT
#undef string_aa
#undef string_bb
#undef string_cc
#endif
